package f00f.net.napster.japster;

import java.util.Hashtable;
import java.util.StringTokenizer;
import java.net.*;
import java.io.*;
import java.util.Enumeration;

import f00f.net.napster.japster.download.*;
import f00f.net.napster.japster.util.*;
import f00f.net.napster.japster.server.*;
import f00f.net.napster.japster.messages.*;
import f00f.net.napster.japster.messages.client.*;
import f00f.net.napster.japster.messages.server.*;
import f00f.net.napster.japster.messages.shared.*;


public class Test
{
	public static void main(String args[])
	{
	try
	{
		System.out.println("Registering Messages");
		MessageFactory factory = new MessageFactory();
		factory.registerMessage(new LoginAck());
		factory.registerMessage(new Motd());
		factory.registerMessage(new ErrorMsg());
		factory.registerMessage(new FatalError());
		factory.registerMessage(new ServerStats());
		factory.registerMessage(new SearchResult());
		factory.registerMessage(new EndSearchResponse());
		factory.registerMessage(new DownloadAck());
	
		Server server = new Server(factory);
		
		ServerMessage message;
		MessageQueue queue;
		
		do
		{
			System.out.print("Finding host...");
			String serverName = server.findHost("server.napster.com:8875");
			System.out.println("ok");

//			String serverName = "207.195.111.2:8888"; // bitchx - opennap
//			String serverName = "209.166.191.64:8888"; // chemlab - opennap
//			String serverName = "207.195.111.5:8888"; // squidcafe - opennap
//			String serverName = "205.161.144.22:8888";

			System.out.print("Connecting...");
			server.connect(serverName);
			System.out.println("ok");

			Login login = new Login("xenoc32","mine123",6669,"japster 0.0.1",1);
		
			queue = server.getMessageQueue();
			queue.sendMessage(login);
			
			message = queue.waitForMessage(5000);
			System.out.println("<- "+message);
		
		} while (!(message instanceof LoginAck));
		
		
		// get the server stats.  if the server doesn't send it, ask for it.
		do
		{
			message = queue.waitForMessage(ServerStats.TYPECODE, 2000);
			
			if (!(message instanceof ServerStats))
				queue.sendMessage( new ServerStats() );
			
		} while (!(message instanceof ServerStats));
		
		System.out.println("<- "+message);
		
		// read the MOTD
		while ( ( message = queue.waitForMessage(Motd.TYPECODE, 1000)) != null )
		{
			System.out.println("<- "+message);
		}
		
		
		BufferedReader reader
			= new BufferedReader( new InputStreamReader(System.in) );
		System.out.print("Artist: ");
		String artist = reader.readLine();
		System.out.print("Song: ");
		String song = reader.readLine();
		
		Search search = new Search(artist, song, 20);
		search.setBitRate(">", 128);
		search.setLineSpeed(">",4);
		search.setFrequency(">",44100);
		
		SearchResults results = new SearchResults();
		queue.sendMessage(search);
		do
		{
			message = queue.waitForMessage(SearchResult.TYPECODE, 1000);
			if (message == null)
			{
				// didn't return a result.  is the search over?
				if (queue.hasMessage(EndSearchResponse.TYPECODE))
					message = queue.nextMessage(EndSearchResponse.TYPECODE);
			}
			else
			{
				System.out.println("<- "+message);
				results.addResult( (SearchResult)message );
			}
		} while (!(message instanceof EndSearchResponse));
		
		System.out.println("<- "+message);


		System.out.println("Processing results");
		results = results.trimFieldGreaterThan(SearchResult.FIELD_BITRATE, 192);
		int meanLength = results.findMeanValue(SearchResult.FIELD_LENGTH);
		results = results.trimFieldGreaterThan(SearchResult.FIELD_LENGTH,
			meanLength);
		results = results.trimFieldLessThan(SearchResult.FIELD_LENGTH,
			meanLength);
		
		results.sort(SearchResult.FIELD_LINK);
		results.sort(SearchResult.FIELD_BITRATE);
		
		for (int x=0; x<results.size(); ++x)
			System.out.println(results.elementAt(x));
		
		int x = 0;
		do
		{
			System.out.println("x="+x);
			SearchResult result = (SearchResult)results.elementAt(x);

			DownloadRequest downloadRequest = result.getDownloadRequest();
			
			queue.sendMessage(downloadRequest);
			
			message = queue.waitForMessage(DownloadAck.TYPECODE, 5000);
			
			System.out.println("<- "+message);
			
			if ( message instanceof DownloadAck &&
				((DownloadAck)message).getPort() != 0)
			{
			
				NapsterDownload download = new NapsterDownload(result,
					(DownloadAck)message);

				if (!download.download())
					message = null;

			}
			
			++x;
		} while ( message == null || ((DownloadAck)message).getPort()==0);

	}
	catch (Exception e)
	{
		e.printStackTrace(System.err);
	}
	}
}
