package f00f.net.napster.japster.download;

import java.io.*;
import java.net.*;

public class Download extends InputStream
{
	private Socket sock;
	private InputStream in;
	private OutputStream out;

	public Download(Socket sock, OutputStream out)
		throws IOException
	{
		this.sock = sock;
		this.out = out;
		this.in = sock.getInputStream();
	}

	public int available()
		throws IOException
	{
		return in.available();
	}
	
	public void close()
		throws IOException
	{
		in.close();
		sock.close();
	}
	
	public void mark(int readlimit)
	{
	}
	
	public boolean markSupported()
	{
		return false;
	}
	
	public int read()
		throws IOException
	{
		return in.read();
	}
	
	public int read(byte[] b, int off, int len)
		throws IOException
	{
		return in.read(b, off, len);
	}
	
	public void reset()
		throws IOException
	{
		in.reset();
	}
	
	public long skip(long n)
		throws IOException
	{
		return in.skip(n);
	}
	
	public void write(int b)
		throws IOException
	{
		out.write(b);
	}
	
	public void write(byte[] b)
		throws IOException
	{
		out.write(b);
	}
	
	public void write(byte[] b, int off, int len)
		throws IOException
	{
		out.write(b, off, len);
	}
	
}
