package f00f.net.napster.japster.download;

import java.io.*;
import java.net.*;
import java.util.*;

import f00f.net.napster.japster.messages.server.*;

public class NapsterDownload
{
	private SearchResult result;
	private DownloadAck ack;

	public NapsterDownload(SearchResult result, DownloadAck ack)
	{
		this.result = result;
		this.ack = ack;
	}
	
	public boolean download()
	{
	try
	{
		Socket sock = new Socket( ack.getIP(), ack.getPort() );
		
		InputStream in = sock.getInputStream();
		while (in.available() == 0)
			Thread.yield();
		
		int b = in.read();
		if (b == (int)'1')
			System.out.println("Yeehaw");
		
		OutputStream out = sock.getOutputStream();
		out.write( "GET".getBytes() );
		
		String filename = result.getFileName();
		String get = "xenoc32 \""+filename+"\" 0";
		out.write( get.getBytes() );
		
		StringTokenizer tok = new StringTokenizer(filename, "\\/");
		
		String localFilename = "test.mp3";
		while (tok.hasMoreElements())
		{
			localFilename = tok.nextToken();
		}
		/*
		int loc = localFilename.lastIndexOf("\\");
		if (loc >= 0)
		{
			localFilename = localFilename.substring(loc+1);
		}
		*/
		File file = new File(localFilename);
		int x = 1;
		while (file.exists())
		{
			file = new File(localFilename+"."+x);
			++x;
		}
		
		FileOutputStream fileOut = new FileOutputStream(file);
		
		Download dl = new Download(sock, fileOut);
		
		try
		{
			SmartDownload smartDownload = new SmartDownload(dl,
				new DownloadManager() );

			return smartDownload.download();
		}
		catch (NumberFormatException e)
		{
			e.printStackTrace(System.err);
			return false;
		}
		
//		sock.close();
//		return true;
	}
	catch (IOException e)
	{
		e.printStackTrace(System.err);
		return false;
	}
	}
}
