package f00f.net.napster.japster.download;

public class RateMonitor implements Runnable
{
	private SmartDownload download;
	private int rate = 0;
	private boolean done = false;
	private int slowCount = 0;
	private boolean tooSlow = false;
	private DownloadManager manager;

	public RateMonitor(SmartDownload download, DownloadManager manager)
	{
		this.download = download;
		this.manager = manager;
	}
	
	public void run()
	{
		int lastSize = 0;
		int size = download.getSize();
		do
		{
			try
			{
				Thread.sleep(1000);
			}
			catch (InterruptedException e)
			{
				//e.printStackTrace(System.err);
			}
			lastSize = size;
			size = download.getSize();
			rate = size - lastSize;
			
			if (rate < manager.getSlowRate())
				++slowCount;
			else
				slowCount = Math.max(slowCount-1, 0);
			
			System.out.print("Rate = "+rate+" bytes/sec");
			if (rate < manager.getSlowRate())
				System.out.println(" (slow "+slowCount+"/"+
					manager.getSlowTimeLimit()+")");
			else
				System.out.println();
				
			if (slowCount > manager.getSlowTimeLimit())
			{
				System.out.println("slow for too long, terminating download");
				tooSlow = true;
			}
		}
		while (!done && !tooSlow);
	}
	
	public void setDone()
	{
		done = true;
	}
	
	public boolean isTooSlow()
	{
		return tooSlow;
	}
	
	public int getRate()
	{
		return rate;
	}

}
