package f00f.net.napster.japster.messages.server;

import f00f.net.napster.japster.messages.server.ServerMessage;
import f00f.net.napster.japster.util.DataTokenizer;

public class DownloadAck implements ServerMessage
{
	public static final short TYPECODE = 0xcc;

	private String nick;
	private String ip;
	private int port;
	private String filename;
	private String md5;
	private int link;
		
	public DownloadAck()
	{
	}
	
	public int getPort()
	{
		return port;
	}
	
	public String getIP()
	{
		return ip;
	}
	
	public String getAddress()
	{
		return ip+":"+port;
	}

	public DownloadAck(String nick, String ip, int port, String filename,
		String md5, int link)
	{
		this.nick = nick;
		this.ip = ip;
		this.port = port;
		this.filename = filename;
		this.md5 = md5;
		this.link = link;
	}
	
	public short getTypeCode()
	{
		return TYPECODE;
	}
	
	public String getData()
	{
		return "huh?";
	}
	
	public ServerMessage getInstance(String data)
	{
		DataTokenizer tok = new DataTokenizer(data);
		String nick = tok.nextToken();
		String ip = tok.nextTokenIP();
		int port = tok.nextTokenInt();
		String filename = tok.nextToken();
		String md5 = tok.nextToken();
		int link = tok.nextTokenInt();
		return new DownloadAck(nick, ip, port, filename, md5, link);
	}
	
	public String toString()
	{
		return "DownloadAck: nick="+nick+" filename='"+filename+"'"+
			" ip="+ip+" port="+port;
	}
}
