package f00f.net.napster.japster.messages.server;

import f00f.net.napster.japster.messages.server.ServerMessage;
import f00f.net.napster.japster.messages.client.DownloadRequest;
import f00f.net.napster.japster.util.DataTokenizer;

public class SearchResult implements ServerMessage
{
	public static final short TYPECODE = 0xc9;

	public static final int FIELD_SIZE = 0;
	public static final int FIELD_BITRATE = 1;
	public static final int FIELD_FREQUENCY = 2;
	public static final int FIELD_LENGTH = 3;
	public static final int FIELD_LINK = 4;
	public static final int FIELD_WEIGHT = 5;
	

	private String filename;
	private String md5;
	private int size;
	private int bitrate;
	private int frequency;
	private int length;
	private String nick;
	private int ip;
	private int link;
	private int weight;
	
	public int getField(int field)
	{
		if (field == FIELD_SIZE)
			return size;
		else if (field == FIELD_BITRATE)
			return bitrate;
		else if (field == FIELD_FREQUENCY)
			return frequency;
		else if (field == FIELD_LENGTH)
			return length;
		else if (field == FIELD_LINK)
			return link;
		else if (field == FIELD_WEIGHT)
			return weight;
		else
			return 0;
	}
	
	public SearchResult()
	{
	}
	
	public SearchResult(String filename, String md5, int size, int bitrate,
		int frequency, int length, String nick, int ip, int link,
		int weight)
	{
		this.filename = filename;
		this.md5 = md5;
		this.size = size;
		this.bitrate = bitrate;
		this.frequency = frequency;
		this.length = length;
		this.nick = nick;
		this.ip = ip;
		this.link = link;
		this.weight = weight;
	}
	
	public short getTypeCode()
	{
		return TYPECODE;
	}
	
	public String getData()
	{
		return "huh?";
	}
	
	public ServerMessage getInstance(String data)
	{
/*	public SearchResult(String filename, String md5, int size, int bitrate,
		int frequency, int length, String nick, String ip, int link,
		int weight)*/
		DataTokenizer tok = new DataTokenizer(data);
		String filename = tok.nextToken();
		String md5 = tok.nextToken();
		int size = tok.nextTokenInt();
		int bitrate = tok.nextTokenInt();
		int frequency = tok.nextTokenInt();
		int length = tok.nextTokenInt();
		String nick = tok.nextToken();
		int ip = tok.nextTokenInt();
		int link = tok.nextTokenInt();
		int weight = 0;
		if (tok.hasMoreElements())
			weight = tok.nextTokenInt();
		return new SearchResult(filename, md5, size, bitrate, frequency,
			length, nick, ip, link, weight);
	}
	
	public String toString()
	{
		/*		
		return "SearchResult: bitrate="+bitrate+" frequency="+frequency+
			" size="+size+" length="+length+" ip="+ip+" nick="+nick+
			" link="+link+" weight="+weight+" filename='"+filename+"'";
		*/
		return "SearchResult: bitrate="+bitrate+" length="+length+
			" link="+link+" nick="+nick;
	}
	
	public DownloadRequest getDownloadRequest()
	{
		return new DownloadRequest(nick, filename);
	}
	
	public String getFileName()
	{
		return filename;
	}
}
