package f00f.net.napster.japster.server;

import java.util.StringTokenizer;
import java.util.LinkedList;
import java.net.*;
import java.io.*;

import f00f.net.napster.japster.messages.MessageQueue;
import f00f.net.napster.japster.messages.MessageFactory;
import f00f.net.napster.japster.messages.Message;
import f00f.net.napster.japster.messages.server.ServerMessage;
import f00f.net.napster.japster.util.SearchResults;

public class Server
{
	private Socket sock = null;
	
	private MessageFactory factory;
	private MessageQueue queue = null;

	public Server(MessageFactory factory)
	{
		this.factory = factory;
	}
	
	public String findHost(String metaServer)
		throws UnknownHostException, IOException
	{
		StringTokenizer metaTok = new StringTokenizer(metaServer,":");
		if (metaTok.countTokens()<1 || metaTok.countTokens()>2)
			throw new IllegalArgumentException();
		String metaHost = metaTok.nextToken();

		String metaPort;
		if (metaTok.countTokens()==2)
			metaPort = metaTok.nextToken();
		else
			metaPort = "8875";
		
		Socket sock = new Socket(metaHost, (new Integer(metaPort)).intValue());
		BufferedReader in = new BufferedReader(
			new InputStreamReader( sock.getInputStream() ) );
		String server = in.readLine();
		sock.close();
		return server;
	}
	
	public boolean connect(String server)
	{
		if (sock != null)
			close();
	
		StringTokenizer serverTok = new StringTokenizer(server, ":");
		if (serverTok.countTokens() < 2)
			throw new IllegalArgumentException();
		String host = serverTok.nextToken();
		String port = serverTok.nextToken();

		try
		{		
			sock = new Socket( host, (new Integer(port)).intValue() );
			sock.setKeepAlive(true);
		}
		catch (UnknownHostException e)
		{
			e.printStackTrace(System.err);
			return false;
		}
		catch (IOException e)
		{
			e.printStackTrace(System.err);
			return false;
		}
		
		try
		{
			queue = new MessageQueue(sock, factory);
		}
		catch (IOException e)
		{
			e.printStackTrace(System.err);
			return false;
		}
		
		return true;
	}
	
	public MessageQueue getMessageQueue()
	{
		return queue;
	}
	/*	
	public SearchResults waitForSearchResults()
	{
		SearchResults results = null;
		try
		{
			while ( (results = listener.getResults()) == null)
				Thread.sleep(100);
		}
		catch (InterruptedException e)
		{
			e.printStackTrace(System.err);
		}
		return results;
	}

	public void addListener(NapsterListener listener)
	{
		this.listener = listener;
		listenerThread = new Thread(listener);
		listenerThread.start();
	}
	*/
	public void close()
	{
		try
		{
			sock.close();
			sock = null;
		}
		catch (IOException e)
		{
			e.printStackTrace(System.err);
		}
	}
	/*
	public void pauseListener()
	{
		listener.pause();
	}

	public void unpauseListener()
	{
		listener.unpause();
	}
	*/
}
